// SmartUpdate Installation Script
// Web Publisher Applet for Enterprise Server 3.5
// Netscape Communications Corporation 1997
//
// ahong@netscape.com
//
// This script is based on what is available in Communicator 4.0.3
//

// Set global variables
var updateObjectName    = "Netscape Web Publisher";
var updateObjectPackage = "Java/Download/WebPub";
var updateObject        = "WebPubArchive.jar";
var versionMaj = 1;
var versionMin = 0;
var versionRel = 5;
var versionBld = 980925;
var bObjectPlugIn = false;


// Conditional alert
function cAlert (message) {
	if (!this.silent)
		alert(message);
}

// Conditional confirm
function cConfirm (message) {
	if (this.silent)
		return true;
	else
		return confirm(message);
}

// Determine install folder
//	if the object to install is a plugin, then get the "Plugins" dir
//	otherwise use the Java Download directory, but on UNIX,
//      that does not work (it is a bug which may be fixed in 4.0.5).
//      The user must change their CLASSPATH to make it work.  e.g. 
//              setenv CLASSPATH /u/ahong/.netscape/java/download/applet.jar:
//                      $CLASSPATH
//      Well, turns out on Mac & Windows Navigator has a hard time finding the 
//	applet right after installation; the user should restart navigator
//	then it'll be all fine 
//
function cGetFolder (su) {
	var folder;

	if (bObjectPlugIn) 
		folder = "Plugins";		
	else
		folder = "Java Download";
	
	return su.GetFolder(folder);	
}

// Variable indicating whether or not installation should proceed.
var bInstall = true;

// Make sure Java is enabled before doing anything else.
if ( !navigator.javaEnabled() ) {
	bInstall = false;
	cAlert ("Java must be enabled to install!");
}

// If all conditions look good, proceed with the installation.
if (bInstall) {

	var bAbort = false;

	// Create a version object and a software update object
	vi = new netscape.softupdate.VersionInfo(versionMaj, versionMin, versionRel, versionBld);
	su = new netscape.softupdate.SoftwareUpdate(this,updateObjectName);

	// Start the install process
	err = su.StartInstall(updateObjectPackage, vi,
		netscape.softupdate.SoftwareUpdate.FULL_INSTALL);
	if (err != 0) {
		cAlert ("Installation error. Aborting.");
		bAbort = true;
	} else {

		// Find the plugins directory on the user's machine
		instFolder = cGetFolder(su);

		err = su.AddSubcomponent("", vi, 
			updateObject, instFolder, "", this.force);
		bAbort = bAbort || (err !=0 );

		// Unless there was a problem, move files to final location
		// and update the Client Version Registry
		if (bAbort) {
			cAlert ("Installation error. Aborting.");
			su.AbortInstall();
		} else {
			err = su.FinalizeInstall();

                        if (!bObjectPlugIn) {
                                if ((navigator.platform == "Win32") ||
                                    (navigator.platform == "Win16") ||
                                    (navigator.platform == "MacPPC") ||
                                    (navigator.platform == "Mac68k"))
					msg = "Installation complete!  \n" +
					"You must restart Navigator to \n" +
					"finish this installation!";
				else
					msg = "Installation complete!  \n" +
					"You must modify your CLASSPATH to \n" +
					"include " +updateObject + ", then \n" +
					"restart Navigator to finish this \n" +
					"installation.  ";
			}

			// Refresh list of available plug-ins
			if (err == 0) {
				navigator.plugins.refresh(true);
				if (!bObjectPlugIn) cAlert(msg);
			}
			else if (err == 999) 
				cAlert("You must reboot to finish this installation!");
		}
		if ( bAbort || err != 0 )
			cAlert("Install cancelled!");

	}

}
